//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                   1.1.Data EXPANDERS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_74HC595_DEV    dv74HC595;   RT_HW_STRUCT_SHED_TASK sh74HC595;                   uint32_t vGenRun;
RT_HW_MCP23x17_DEV   dvMCP23x17;  RT_HW_STRUCT_SHED_TASK shMCP23x17in, shMCP23x17out; uint8_t  mcp23x17inA,mcp23x17inB;
RT_HW_PCF8575_DEV    dvPCF8575;   RT_HW_STRUCT_SHED_TASK shPCF8575in,  shPCF8575out;  uint8_t  vPCF8575inA=0, vPCF8575inB=0;
RT_HW_MCP4725_DEV    dvMCP4725;   RT_HW_STRUCT_SHED_TASK shMCP4725; 
//=================================================================================================

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                   1.2.Data Generators, Сounter
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_GENERATOR_EVENT_ID idGenRun;      RT_HW_COUNTER_ID idCntRun8;     uint8_t  vGenRun8=0;  //--For generator running "1" 0-8;
                                        RT_HW_COUNTER_ID idCntRun16;    uint16_t vGenRun16=0; //--For generator running "1" 0-16;
                                        RT_HW_COUNTER_ID idCntRun24;    uint32_t vGenRun24=0; //--For generator running "1" 0-24;
                                        RT_HW_COUNTER_ID idCntRun32;    uint32_t vGenRun32=0; //--For generator running "1" 0-32;
RT_HW_GENERATOR_EVENT_ID idGenA,idGenB; RT_HW_COUNTER_ID idCntA,idCntB; uint8_t  vCntA,vCntB,vGenA,vGenB;  //--For generator MCP23x17;
RT_HW_GENERATOR_EVENT_ID idGenDAC;      RT_HW_COUNTER_ID idCntDAC;      uint16_t vGenDAC=0;                //--For generator 0-4095 DAC;
//=================================================================================================
void  genRun(void){
if(idCntRun8.reset) {RT_HW_Base.counterReset(idCntRun8,  8,0,1,1);}  //--init counter: Upper limit=8,   Down limit=0, Change step=1,   Initial value=0;
if(idCntRun16.reset){RT_HW_Base.counterReset(idCntRun16,16,0,1,1);}  //--init counter: Upper limit=16,  Down limit=0, Change step=1,   Initial value=0;
if(idCntRun24.reset){RT_HW_Base.counterReset(idCntRun24,24,0,1,1);}  //--init counter: Upper limit=24,  Down limit=0, Change step=1,   Initial value=0;
if(idCntRun32.reset){RT_HW_Base.counterReset(idCntRun32,32,0,1,1);}  //--init counter: Upper limit=32,  Down limit=0, Change step=1,   Initial value=0;
if(RT_HW_Base.generatorEvent(idGenRun,50)){ vGenRun8= RT_HW_Base.dc8(RT_HW_Base.counterS(idCntRun8));
                                            vGenRun16=RT_HW_Base.dc16(RT_HW_Base.counterS(idCntRun16));
                                            vGenRun24=RT_HW_Base.dc24(RT_HW_Base.counterS(idCntRun24));
                                            vGenRun32=RT_HW_Base.dc32(RT_HW_Base.counterS(idCntRun32));
}}; 
//=================================================================================================

//=================================================================================================
void genAB(){         
if(idCntA.reset){RT_HW_Base.counterReset(idCntA,8,0,1,1);}   //--init counter: Upper limit=8,   Down limit=0, Change step=1,   Initial value=0;
if(idCntB.reset){RT_HW_Base.counterReset(idCntB,8,0,1,1);}   //--init counter: Upper limit=8,   Down limit=0, Change step=1,   Initial value=0;
if(RT_HW_Base.generatorEvent(idGenA,50)) {  vCntA=RT_HW_Base.counterT(idCntA); vGenA=RT_HW_Base.dc8(vCntA);
                                            vCntB=RT_HW_Base.counterS(idCntB); vGenB=RT_HW_Base.dc8(vCntB);
}};
//=================================================================================================
void genDAC(){         
if(idCntDAC.reset){RT_HW_Base.counterReset(idCntDAC,4095,0,10,0);}  //--init counter: Upper limit=4095, Down limit=0, Change step=10, Initial value=0;
if(RT_HW_Base.generatorEvent(idGenDAC,50)){ vGenDAC=RT_HW_Base.counterT(idCntDAC);  //--Triangle generator 0-4095 for DAC,100 ms;
}};
//=================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     4. EXPANDERS I/O
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//                                     4.1. 74HC595.SPI
//=================================================================================================
void ext74HC595(){   
if(dv74HC595.custom==0){dv74HC595.custom=RT_HW_Base.spiSetParam(dv74HC595.dvS,cs74HC595,0,4000000);
                        dv74HC595.mi='S'; dv74HC595.qnt=1; dv74HC595.bitOrder=1;  //--qnt=Number of registers 74HC595(1-4);
                        RT_HW_Base.setTaskID(sh74HC595,'Q');}  //--Setting task: 'Q'-on change output in every  default=5th cycle; 
//-------------------------------------------------------------------------------------------------
if(sh74HC595.custom==0){RT_HW_Base.setTaskID(sh74HC595,'Q');} //  Setting task: 'Q'-on change output in every  default=5th cycle;
//-------------------------------------------------------------------------------------------------
RT_HW_Base.directTask(sh74HC595); 
if(sh74HC595.run){
vGenRun=vGenRun8;
//if(dv74HC595.qnt==1){vGenRun=vGenRun8;}
//if(dv74HC595.qnt==2){vGenRun=vGenRun16;}
//if(dv74HC595.qnt==3){vGenRun=vGenRun24;}
//if(dv74HC595.qnt==4){vGenRun=vGenRun32;}
}
//-------------------------------------------------------------------------------------------------
RT_HW_74hc595.direct(dv74HC595,vGenRun,sh74HC595.run);
};
//=================================================================================================
//                                     4.2. DM13C
//=================================================================================================
RT_HW_GENERATOR_EVENT_ID idGenDM13C;   RT_HW_COUNTER_ID idCntDM13C;     uint8_t vCntDM13C; uint32_t vGenDM13C=0;  //--For generator running "1" 0-8;
RT_HW_STRUCT_SPI_DEV dvDM13C;          RT_HW_STRUCT_SHED_TASK shDM13C;                     uint32_t vDM13C=0,vxDM13C=0; uint32_t inDM13C=0;
//-------------------------------------------------------------------------------------------------
//                                    4.2.1.Генератор DM13C
//-------------------------------------------------------------------------------------------------
void  genDM13C(void){
if(idCntDM13C.reset){RT_HW_Base.counterReset(idCntDM13C,32,0,1,1);}  //--init counter: Upper limit=32,  Down limit=0, Change step=1,   Initial value=0;
//if(RT_HW_Base.generatorEventMcs(idGenDM13C,250000)){ vGenR32=RT_HW_Base.dc32(RT_HW_Base.counterS(idCntR32));}
if(RT_HW_Base.generatorEvent(idGenDM13C,50)){vCntDM13C=RT_HW_Base.counterS(idCntDM13C); vGenDM13C=RT_HW_Base.dc32(vCntDM13C);}
};
//-------------------------------------------------------------------------------------------------
//                                    4.2.2.Вывод на DM13C
//-------------------------------------------------------------------------------------------------
void extDM13C(){
if(dvDM13C.custom==0){//csDM13C=RT_HW_Base.device.spi.cs3; 
                      dvDM13C.custom=RT_HW_Base.spiSetParam(dvDM13C,csDM13C,0,8000000);                    
                      RT_HW_Base.setTaskID(shDM13C, 'Q',5);      //--Вывод каждые 5 циклов диспетчера(frdm) по изменениям;
                     }
RT_HW_Base.directTask(shDM13C);
if(shDM13C.run){RT_HW_Base.spiInitDevice(dvDM13C);
 if(vDM13C!=vGenDM13C){vxDM13C=vDM13C=vGenDM13C; 
                       vxDM13C=vxDM13C | 0x00000F00;
                       //RT_HW_Base.consoleVar(uint16_t(vxDM13C&0xFFFF),' ',0,'h'); if(vCntDM13C==16){RT_HW_Base.consoleCR();}
                       RT_HW_Base.spiTransfer(dvDM13C,vxDM13C,inDM13C,4);
                       
                       
                       }  //-2 чипа,32 входа/выхода;  
}};
//=================================================================================================
//                                     4.3. PCF8575.i2c
//=================================================================================================
void extPCF8575(){ 
if(dvPCF8575.custom==0){dvPCF8575.custom=RT_HW_Base.i2cSetParam(dvPCF8575.dvI,i2cAdrPCF8575,0,0);
                         dvPCF8575.mi='I';
                         dvPCF8575.cnfgA=0xFF; dvPCF8575.invOutA=0xFF;  dvPCF8575.invInA=0xFF;
                         dvPCF8575.cnfgB=0xFF; dvPCF8575.invOutB=0xFF;  dvPCF8575.invInB=0xFF;                     
                         RT_HW_Base.setTaskID(shPCF8575in, 'P',500);  
                         RT_HW_Base.setTaskID(shPCF8575out,'Q',100); 
                        }
RT_HW_Base.directTask(shPCF8575in);
RT_HW_Base.directTask(shPCF8575out);
if(shPCF8575out.run){dvPCF8575.extA=vGenA; dvPCF8575.extB=vGenB;}
RT_HW_pcf8575.direct(dvPCF8575,shPCF8575in.run,shPCF8575out.run);
if(dvPCF8575.fresh){dvPCF8575.fresh=0; vPCF8575inA=dvPCF8575.inA; vPCF8575inB=dvPCF8575.inB;};
};
//=================================================================================================
//                                     4.4.MCP23017.i2c;
//=================================================================================================
void extMCP23x17_i2c(){ 
if(dvMCP23x17.custom==0){dvMCP23x17.custom=RT_HW_Base.i2cSetParam(dvMCP23x17.dvI,i2cAdrMCP23x17,0,0);
                         dvMCP23x17.mi='I';
                         dvMCP23x17.cnfgA=0x00; dvMCP23x17.cnfgIPOLA=0xFF; dvMCP23x17.cnfgGPPUA=0xFF;
                         dvMCP23x17.cnfgB=0x00; dvMCP23x17.cnfgIPOLB=0xFF; dvMCP23x17.cnfgGPPUB=0xFF;                        
                         RT_HW_Base.setTaskID(shMCP23x17in, 'P',500);  
                         RT_HW_Base.setTaskID(shMCP23x17out,'Q',100); 
                        }
RT_HW_Base.directTask(shMCP23x17in);
RT_HW_Base.directTask(shMCP23x17out);
if(shMCP23x17out.run){dvMCP23x17.extA=vGenA; dvMCP23x17.extB=vGenB;}
RT_HW_mcp23x17.direct(dvMCP23x17,shMCP23x17in.run,shMCP23x17out.run);
};
//=================================================================================================
